/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package sociogram;
import simulation.MeasurementEvolution;
import simulation.*;

/**
 * This class measures the evolution of sociograms with groug sociometrics 
 * proposed by (Barrasa, 2008) that are provided by Sociogram class.
 * 
 * @author Iván García-Magariño
 */
public class MeasurementEvolutionSociogram extends MeasurementEvolution{
    /** Constant with the number of metrics of this measurement evolution **/
    public static int NUM_METRICS=4;
    /** Constructor of the class. It calls the constructor of the super class.
     * It sets the names of the group sociometrics. It initiates the matrix
     * of measurement values. It needs the number of iterations as parameter.
     * @param numIterations Number of iterations
     **/
    public MeasurementEvolutionSociogram(int numIterations){
        super(numIterations,NUM_METRICS);
        metrics=new String[NUM_METRICS];
        metrics[0]="IAg";
        metrics[1]="ICg";
        metrics[2]="IDg";
        metrics[3]="IIg";        
    }
    
    /** Measures the group sociometrics of the current sociogram for a 
     * particular iteration, obtaining the information from the blackboard.
     */
    public void recordValues(){
        // Gets the iteration and sociogram
        Simulation simulation = Blackboard.getInstance().getSimulation();
        if(simulation instanceof SimulationAnimation){
            int iteration=((SimulationAnimation)simulation).getIteration();
            Sociogram sociogram=Blackboard.getInstance().getSociogram();
            // Measure the values for the different sociometrics.
            double [] valuesIter=new double[NUM_METRICS];
            valuesIter[0]=sociogram.measureIAg();
            valuesIter[1]=sociogram.measureICg();
            valuesIter[2]=sociogram.measureIDg();
            valuesIter[3]=sociogram.measureIIg();
            // Call the othe other recordValues method
            recordValues(iteration, valuesIter);
        }
        
        
    }
}
