/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package trainingsoci;
import java.util.HashMap;
import trainingdeck.*;

/**
 * It represents the objective of achieving a similar value
 * in the IAg sociometric for the training of the simulator.
 * @author Iván García-Magariño
 */
public class ObjectiveIAg implements ObjectiveSim{
    /**
     * It compares two simulation results based on the IAG socimetric value.
     * @param output1 first simulation output
     * @param output2 second simulation output
     * @return The difference between the values of IAg sociometric. In 
     * particular, it uses (IAg of output1)- (IAg of output2). If diff>0 then
     * IAg of output1 >0.
     */
    @Override
    public double compare(HashMap<String, Object> output1, HashMap<String, Object> output2) {
        double iag1= ((Double)output1.get("IAg")).doubleValue();
        double iag2= ((Double)output2.get("IAg")).doubleValue();
        return iag1-iag2;     
    }
    
}
